'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.solve = solve;

var _force = require('./search/force');

var _ = require('./');

var buildGrid = function buildGrid(rows) {
  var nodeRows = rows.map(function (row) {
    return row.split("").map(function (khar) {
      return new _.CharNode(khar);
    });
  });

  var grid = _.ArrayGrid.fromArray(nodeRows);

  return grid;
};

function solve(rows, words) {
  var allowedDirections = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _.Directions;
  var findMatches = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _force.findMatches;

  var grid = buildGrid(rows);

  // solve
  var matches = findMatches(words, grid, allowedDirections);

  return { matches: matches, grid: grid };
}